local homeVJR = ...

homeVJR:override({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_1",
	Name = "ESSAI_NAME",
	Description = "ESSAI_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    "HOME_VJR_V3_HOME2_PART"
                }
	}
})

homeVJR:override({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
	Name = "ESSAI_NAME",
	Description = "ESSAI_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    "HOME_VJR_V3_HOME11_PART"
                    , "HOME_VJR_V3_HOME3_PART"
                    , "HOME_VJR_V3_HOME4_PART"
                }
	}
})

homeVJR:override({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
	Name = "ESSAI_NAME",
	Description = "ESSAI_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    "HOME_VJR_V3_HOME5_PART",
                    "HOME_VJR_V3_HOME6_PART"
                }
	}
})

function registerBuilding(_fbxName, _buildingAssetId, _buildingZone)
    homeVJR:registerAssetProcessor("models/" .. _fbxName .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })

-- Register common prefab nodes
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/homePart", "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB")

    homeVJR:register({
--Déclare que l'objet que l'on crée appartient à la class BUILDING_PART
	DataType = "BUILDING_PART",
--Créé l'objet
	Id = "HOME_VJR_V3" .. _buildingAssetId .. "_PART",
	Name = "HOME_VJR_V3" .. _buildingAssetId .. "_NAME",
	Description = "HOME_VJR_V3" .. _buildingAssetId .. "_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--on déclare d'aller chercher "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB" pour construire l'object final ( c'est dans le Fbx )
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB"
	},
--Ca c'est pour déclarer le visuel de construction si il y en a un !
	ConstructionVisual = "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB",
--Les ressources nécessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 10 }
		}
	}
    })

-- Override building part components properties (generated by the building asset processor) to add building zones
    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = _buildingZone
    })

-- The fireplace...
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", "HOME_VJR_V3" .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB")

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "HOME_VJR_V3" .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/homePart/step_0/porte", {
	DataType = "COMP_GROUNDED"
    })
end

registerBuilding("Home1", "_HOME1", { 4, 8 })
registerBuilding("Home2", "_HOME2", { 3, 7 })
registerBuilding("Home3", "_HOME3", { 8, 8 })
registerBuilding("Home4", "_HOME4", { 4, 8 })
registerBuilding("Home5", "_HOME5", { 4, 6 })
registerBuilding("Home6", "_HOME6", { 4, 7 })

--------------------------------------------------------------------------
function registerBuildingAssemblage(_fbxName, _buildingAssetId, _buildingZone)
-- Apply building asset processor
    homeVJR:registerAssetProcessor("models/" .. _fbxName .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })
 
-- Register prefab nodes
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB")

-- Register the assemblage part
    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = "HOME_VJR_V3" .. _buildingAssetId .. "_PART",
	Name = "HOME_VJR_V3" .. _buildingAssetId .. "_NAME",
	Description = "HOME_VJR_V3" .. _buildingAssetId .. "_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB" },
                MandatoryBuildingPartList = {
                    { BuildingPart = "HOME_VJR_V3_WOODEN_DOOR_PART" }
                    ,{ BuildingPart = "HOME_VJR_V3_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = "HOME_VJR_V3_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = "HOME_VJR_V3_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = "HOME_VJR_V3_FENETRE_PART", Probability = 0.5 }
                    ,{ BuildingPart = "HOME_VJR_V3_FENETRE_PART", Probability = 0.5 }
               }
	},
--Ca c'est pour déclarer le visuel de construction si il y en a un !
	ConstructionVisual = "HOME_VJR_V3" .. _buildingAssetId .. "_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = _buildingZone
    })

-- several models of door
    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = "HOME_VJR_V3_WOODEN_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
                                "HOME_VJR_V3_DOOR1_PART"
                                , "HOME_VJR_V3_DOOR2_PART"
                                , "HOME_VJR_V3_DOOR3_PART"
                          }
        }
    })

    -- Register the door parts
    function registerPortePart(_doorName, _doorAssetId, _doorZone)
        homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", "HOME_VJR_V3" .. _doorAssetId .. "_PREFAB")

        homeVJR:register({
        	DataType = "BUILDING_PART",
	        Id = "HOME_VJR_V3" .. _doorAssetId .. "_PART",
	        Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		    CoreObjectPrefab = "HOME_VJR_V3" .. _doorAssetId .. "_PREFAB"
	        }
        })

        homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", {
	    DataType = "COMP_BUILDING_PART",
            BuildingPartType = "MAJOR",
	    HasBuildingZone = true,
	    BuildingZone = _doorZone
        })

        homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/" .. _doorName .. "Part", {
	    DataType = "COMP_GROUNDED"
        })
    end

    registerPortePart("door1", "_DOOR1", { 0.1, 1 })
    registerPortePart("door2", "_DOOR2", { 0.1, 1 })
    registerPortePart("door3", "_DOOR3", { 1, 1 })

-- Register the fenetre part
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/fenetrePart", "HOME_VJR_V3_FENETRE_PREFAB")

    homeVJR:register({
	DataType = "BUILDING_PART",
	Id = "HOME_VJR_V3_FENETRE_PART",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HOME_VJR_V3_FENETRE_PREFAB"
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/fenetrePart", {
	DataType = "COMP_BUILDING_PART",
        BuildingPartType = "MAJOR",
	HasBuildingZone = true,
	BuildingZone = { 0.1, 1 }
    })

-- The fireplace...
    homeVJR:registerAssetId("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", "HOME_VJR_V3" .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB")

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "HOME_VJR_V3" .. _buildingAssetId .. "_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
    })

    homeVJR:registerPrefabComponent("models/" .. _fbxName .. ".fbx/Prefab/assemblyHouse/homePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
    })
end

registerBuildingAssemblage("Home11", "_HOME11", { 4, 8 })


