local HomeVJR = ...

-- Register all stone gate set building parts and their properties
--HomeVJR:dofile("scripts/building.lua")

    -- Register core prefab nodes (currently only one core model)
    HomeVJR:registerAssetId("models/Home1.fbx/Prefab/CoreBuildingPart", "HOME_VJR_V3_CORE_BUILDING_PREFAB")

    -- Register the water mill Core part
    HomeVJR:register({
	DataType = "BUILDING_PART",
	Id = "HOME_VJR_V3_CORE_BUILDING_PART",
	Name = "HOME_VJR_V3_CORE_BUILDING_NAME",
	Description = "HOME_VJR_V3_CORE_BUILDING_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HOME_VJR_V3_CORE_BUILDING_PREFAB"
	},
        IsVisibleWhenBuilt = false
    })


local myMonument = {
    Id = "HOME_VJR_V3_MONUMENT",
    Name = "HOME_VJR_V3_MONUMENT_NAME",
    Description = "HOME_VJR_V3_MONUMENT_DESC",
    BuildingType = "MONUMENT"
}

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    HomeVJR:log("Hello World: version 1.5")
    myMonument.DataType = "MONUMENT"
else
    HomeVJR:log("Hello World: version 1.6")
    myMonument.DataType = "BUILDING"
    myMonument.AssetCoreBuildingPart = "HOME_VJR_V3_CORE_BUILDING_PART"
end

-- Register the stone gate set monument
myMonument.BuildingPartSetList = {
		{
			Name = "HOME_VJR_V3_PARTSETLIST_NAME",
	                BuildingPartList = {
--                            "BUILDING_PART_HOUSING_SERF_DENSITY_1",
--                            "BUILDING_PART_HOUSING_SERF_DENSITY_2",
--                            "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
		            "HOME_VJR_V3_HOME1_PART",
		            "HOME_VJR_V3_HOME2_PART",
		            "HOME_VJR_V3_HOME3_PART",
		            "HOME_VJR_V3_HOME4_PART",
		            "HOME_VJR_V3_HOME5_PART",
		            "HOME_VJR_V3_HOME6_PART",
		            "HOME_VJR_V3_HOME11_PART"
                         }
                 }
}
myMonument.RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
}
myMonument.IsEditable = true

HomeVJR:register(myMonument)

